// This is the library code file for the Dual D/A 12 board for Arduino
// Rev B 19Jul15  Fix low range code Ch B

#include "Arduino.h"
#include "Ardda.h"
#include <SPI.h>

static unsigned char ACON,BCON;
static int CS,LD;

int ArddaClass::Setup(int l, int c, int a, int b)
{
    CS = c;
    LD = l;
    pinMode(CS,OUTPUT);
    pinMode(LD,OUTPUT);
    digitalWrite(CS,HIGH);
    digitalWrite(LD,HIGH);
    if(a == 5)
    {
        ACON=0x30;
    }
    else
    {
        ACON=0x10;
    }
    if(b == 5)
    {
        BCON=0xB0;
    }
    else
    {
        BCON=0x90;
    }
}

int ArddaClass::OutA(float aval)
{
    unsigned char avalL,avalH;
    unsigned int ival;
    if(aval < 0.0)
        aval=0.0;
    if(ACON == 0x30)
    {
        if(aval > 4.998)
            aval=4.998;
        ival=aval/1.221e-3;
    }
    else
    {
        if(aval > 9.997)
            aval=9.997;
        ival=aval/2.4414e-3;
    }
    avalL = ival & 0x00FF;
    avalH = (ival & 0x0F00) >> 8;
    avalH = avalH | ACON;
    digitalWrite(CS,LOW);
    delayMicroseconds(10);
    SPI.transfer(avalH);
    SPI.transfer(avalL);
    delayMicroseconds(10);
    digitalWrite(CS,HIGH);
    delayMicroseconds(10);
    digitalWrite(LD,LOW);
    delayMicroseconds(50);
    digitalWrite(LD,HIGH);
}

int ArddaClass::OutB(float bval)
{
    unsigned char bvalL,bvalH;
    unsigned int ival;
    if(bval < 0.0)
        bval=0.0;
    if(BCON == 0xB0)
    {
        if(bval > 4.998)
            bval=4.998;
        ival=bval/1.221e-3;
    }
    else
    {
        if(bval > 9.997)
            bval=9.997;
        ival=bval/2.4414e-3;
    }
    bvalL = ival & 0x00FF;
    bvalH = (ival & 0x0F00) >> 8;
    bvalH = bvalH | BCON;
    digitalWrite(CS,LOW);
    delayMicroseconds(10);
    SPI.transfer(bvalH);
    SPI.transfer(bvalL);
    delayMicroseconds(10);
    digitalWrite(CS,HIGH);
    delayMicroseconds(10);
    digitalWrite(LD,LOW);
    delayMicroseconds(50);
    digitalWrite(LD,HIGH);
}
ArddaClass Ardda;
